<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Rating extends Controller_Handler
{
    /** @var  Model_Rating */
    protected $model;

    public function before() {
        parent::before();

        $this->user->checkAccess(User::RIGHTS_TEACHER);
        $this->model = new Model_Rating;
    }

    public function action_SetRate() {
        $data['success'] = false;

        $this->post->rule('rate', 'numeric')
            ->rule('rate', 'range', [':value', -2, 100]);

        if ($this->post->check()) {
            $result = Model_Rating::SetStudentRate($this->user->TeacherID, $_POST['studentID'], $_POST['submoduleID'], $_POST['rate']);
            $data['success'] = ($result->get('Num') == 0);
        }

        $this->response->body(json_encode($data));
    }

    public function action_SelectGroup() {
        $res['success'] = false;

        if ($this->post->check()) {
            //$SGID = Cookie::get('SGID', null);
            $SG_json = json_decode(Cookie::get('SGID', null), true);
            $SG_json[$_POST['disciplineID']] = $_POST['groupSelected'];
            Cookie::set('SGID', json_encode($SG_json), '2592000');
            $res['success'] = true;
        }

        $this->response->body(json_encode($res));
    }

    public function action_SetExamPeriodOption() {
        $res['success'] = false;

        if ($this->post->check()) {
            // option check
            $parametersCheckPassed = true;
            switch ($_POST['option']) {
                case 'null' :
                case 'absence':
                case 'pass':
                    break;
                default:
                    $parametersCheckPassed = false;
            }

            if ($parametersCheckPassed) {
                $result = Model_Rating::setExamPeriodOption($_POST['studentID'], $_POST['submoduleID'], $_POST['option']);
                $res['success'] = !$result['ErrorCode'];
            }
        }

        $this->response->body(json_encode($res));
    }
}
