<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Student_Index extends Controller_Environment_Student
{
    public function action_index() {
        $student = Model_Student::load($this->user->StudentID);
        $disciplines = $student->getDisciplines();
        $marks = [];

        foreach ($disciplines as $dis) {
            if (isset($dis->Rate) && isset($dis->MaxCurrentRate))
                $marks[$dis->ID] = Model_Subject::getECTSMark($dis->Rate, $dis->MaxCurrentRate, $exam = NULL);
        }

        $teachers = $student->getTeachers();
        foreach ($teachers as $disID => &$list) {
            $list = Controller_Teacher_Index::getShortListOfTeachers($list);
        }

        $this->twig->set([
            'Marks'        => $marks,
            'Disciplines'  => $disciplines,
            'Teachers'     => $teachers,
            'SemesterList' => Model_Semesters::loadAll(),
        ])->set_filename(static::STUDENT . 'index');
    }

    public function action_settings() {
        $this->twig->set_filename('settings');
    }
}

