<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Index extends Controller_Environment_Teacher
{
    public function action_index() {
        $teacher = Model_Teacher::with($this->user->TeacherID);
        $disciplines = $teacher->getDisciplines();
        $subjID = $discID = $gradeNum = $i = 0;
        $subjects = $teachers = $groups = [];

        foreach ($disciplines as $dis) {
            // group disciplines by subjectID & gradeID
            if ($subjID != $dis->SubjectID || $gradeNum != $dis->GradeID) {
                $subjID = $dis->SubjectID;
                $gradeNum = $dis->GradeID;

                $subjects[++$i] = [
                    'SubjectName' => $dis->SubjectName,
                    'GradeNum'    => $dis->GradeNum,
                    'Degree'      => $dis->Degree,
                ];
            }

            if ($discID != $dis->ID) {
                $discID = $dis->ID;
                $subjects[$i]['Disciplines'][] = $dis;
            }

            $scientific = $dis->Subtype == Model_CourseWork::SCIENTIFIC;

            // todo: Pavel will write an optimized query
            if (!$scientific && !$teachers[$dis->ID]) {
                $list = $dis->getTeachers()->groupByUniqueKey('ID');
                $teachers[$dis->ID] = $this->getShortListOfTeachers($list, $dis->AuthorID, $this->user->TeacherID);
            }
            if (isset($dis->GroupNum) && $dis->GroupNum)
                $groups[$dis->ID][] = $dis->GroupNum . ' гр.';
        }

        $this->twig->set([
            'Subjects'     => $subjects,
            'Teachers'     => $teachers,
            'Groups'       => $groups,
        ])->set_filename('teacher/index');
    }

    public static function getShortListOfTeachers(&$teachers, $authorID = null, $vipID = null) {
        $short = [];

        // place vip & author at the beginning
        foreach ($teachers as $id => &$teacher) {
            if ($id == $authorID || $id == $vipID)
                $short += [$id => $teacher];
        }

        return $short + Arr::shuffle_assoc($teachers);
    }

    public function action_settings() {
        $this->twig->set_filename('settings');
    }
}
